      *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)
      *_> DLTMOD MODULE(@5/@4)
      *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +
      *_>   DBGVIEW(@9) OPTIMIZE(@8) OPTION(*EVENTF)
      *=============================================================================================
      * Module.....: XVERRH_M01
      * By.........: Alan Campin
      * Date.......: 08/26/2008
      * Purpose....: Error Handling Functions. This module contains
      *                a function to throw errors back to the caller.
      *---------------------------------------------------------------------------------------------
      * Program Modification Section:
      *------------------------------
      * By.........:
      * Date.......:
      * Description:
      *=============================================================================================
     h nomain
     h Option(*Srcstmt:*Nodebugio:*NoShowCpy)

      /copy *libl/qsrcf,cb_StdType
      /copy *libl/qsrcf,cb_Std_Con
      /copy *libl/qsrcf,xverrh_pr

     d ILE_SignalError...
     d                 pr                  ExtProc('CEESGL')
     d   PR_InOutConditionToken...
     d                                     Like(StdCndTok)
     d   PR_InDataToken...
     d                                     Like(StdInt)
     d                                     Const
     d                                     Options(*Omit)
     d   PR_OutFeedback...
     d                                     Like(StdCndTok)
     d                                     Options(*Omit)
      *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
      * ERRH_Throw
      *   This procedure throws a message back to previous caller where it
      *    must be handling or error will be generated.
      *       In     Parms - Message Id of Error.
      *                      Qualified Message File Name.
      *                      Message Data.
      *       In/Out Parms - None.
      *       Out    Parms - None.
      *     Return         - None.
      *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     p ERRH_Throw...
     p                 b                   Export
     d                 pi
     d   InMessageId...
     d                                     Like(StdMsgId)
     d                                     Value
     d   InQualifiedMessageFileName...
     d                                     Like(StdQNam)
     d                                     Value
     d   InMessageData...
     d                             1024    Varying
     d                                     Value

      /copy *libl/qsrcf,CB_STD_EM

     d SendProgramMessage...
     d                 pr                  ExtPgm('QMHSNDPM')
     d  PR_MessageId...
     d                                     Like(StdMsgId)
     d                                     Const
     d  PR_QualifiedMessageFile...
     d                                     Like(StdQNam)
     d                                     Const
     d  PR_MessageData...
     d                             1024    Options(*VarSize)
     d                                     Const
     d  PR_MessageDataLength...
     d                                     Like(StdInt)
     d                                     Const
     d  PR_MessageType...
     d                                     Like(StdNam)
     d                                     Const
     d  PR_ToCallStackEntry...
     d                            32767    Options(*VarSize)
     d                                     Const
     d  PR_ToCallStackEntryCounter...
     d                                     Like(StdInt)
     d                                     Const
     d  PR_MessageKey...
     d                                     Like(StdMsgKey)
     d  PR_ErrorReturn...
     d                                     LikeDs(TD_StdErrorModel)

     d MessageKey...
     d                 s                   Like(StdMsgKey)
     d ErrorReturn...
     d                 ds                  LikeDs(TD_StdErrorModel)
     d ConditionToken...
     d                 s                   Like(StdCndTok)

     d MsgUXV0021...
     d                 ds                  Qualified
     d   MessageId...
     d                                     Like(StdMsgId)
     d   MessageData...
     d                             1024    Varying
      /Free

       // Store message.
       ERRH_AddMessage(InMessageId               :
                       InQualifiedMessageFileName:
                       InMessageData             );

       ErrorReturn.Size = %Size(TD_StdErrorModel);
       ErrorReturn.BytesAvailable = 0;

       SendProgramMessage(InMessageId               :
                          InQualifiedMessageFileName:
                          InMessageData             :
                          %Len(InMessageData)       :
                          '*ESCAPE'                 :
                          '*'                       :
                          1                         :
                          MessageKey                :
                          ErrorReturn               );

       // If error occurs, send a notification message.
       If ErrorReturn.BytesAvailable > 0;
         MsgUXV0021.MessageId   = ErrorReturn.MessageId;
         MsgUXV0021.MessageData = %Trim(ErrorReturn.MessageData);
         ERRH_AddMessage('UXV0021'         :
                         cXVMessageFileName:
                         MsgUXV0021        );
         ConditionToken = ERRH_BuildConditionToken('CPF9899'         :
                                                   99                :
                                                   cConditionTypeUser);
         ILE_SignalError(ConditionToken:*Omit:*Omit);
       EndIf;

       Return;

      /End-Free
     p                 e
      *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
      * ERRH_Rethrow
      *   This procedure re-throw the last message sent. It is meant to be
      *     used by a procedure to send a message up the line from another
      *     procedure in the same module.
      *       In     Parms - None.
      *       In/Out Parms - None.
      *       Out    Parms - None.
      *     Return         - None.
      *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     p ERRH_Rethrow...
     p                 b                   Export
     d                 pi

      /copy *libl/qsrcf,CB_STD_EM

     d SendProgramMessage...
     d                 pr                  ExtPgm('QMHSNDPM')
     d  PR_MessageId...
     d                                     Like(StdMsgId)
     d                                     Const
     d  PR_QualifiedMessageFile...
     d                                     Like(StdQNam)
     d                                     Const
     d  PR_MessageData...
     d                             1024    Options(*VarSize)
     d                                     Const
     d  PR_MessageDataLength...
     d                                     Like(StdInt)
     d                                     Const
     d  PR_MessageType...
     d                                     Like(StdNam)
     d                                     Const
     d  PR_ToCallStackEntry...
     d                            32767    Options(*VarSize)
     d                                     Const
     d  PR_ToCallStackEntryCounter...
     d                                     Like(StdInt)
     d                                     Const
     d  PR_MessageKey...
     d                                     Like(StdMsgKey)
     d  PR_ErrorReturn...
     d                                     LikeDs(TD_StdErrorModel)

     d MessageKey...
     d                 s                   Like(StdMsgKey)
     d ErrorReturn...
     d                 ds                  LikeDs(TD_StdErrorModel)
     d ConditionToken...
     d                 s                   Like(StdCndTok)

     d MsgUXV0021...
     d                 ds                  Qualified
     d   MessageId...
     d                                     Like(StdMsgId)
     d   MessageData...
     d                             1024    Varying

     d MsgId...
     d                 s                   Like(StdMsgId)
     d MsgfQ...
     d                 s                   Like(StdQNam)
     d MsgDta...
     d                 s           1024a   Varying
      /Free

       ERRH_GetLastMessage(MsgId :
                           MsgfQ :
                           MsgDta);

       // Throw only if we have a message to throw. We can get
       //   sent here by an unmonitored error.
       If MsgId <> *Blanks;
         ERRH_Throw(MsgId :
                    MsgfQ :
                    MsgDta);
       Else;
         ErrorReturn.Size = %Size(TD_StdErrorModel);
         ErrorReturn.BytesAvailable = 0;

         SendProgramMessage('UXV0058'  :
                            'XVMSGF'   :
                            ' '        :
                            0          :
                            '*ESCAPE'  :
                            '*'        :
                            1          :
                            MessageKey :
                            ErrorReturn);

         // If error occurs, send a notification message.
         If ErrorReturn.BytesAvailable > 0;
           MsgUXV0021.MessageId   = ErrorReturn.MessageId;
           MsgUXV0021.MessageData = %Trim(ErrorReturn.MessageData);
           ERRH_AddMessage('UXV0021'         :
                           cXVMessageFileName:
                           MsgUXV0021        );
           ConditionToken = ERRH_BuildConditionToken('CPF9899'         :
                                                     99                :
                                                     cConditionTypeUser);
           ILE_SignalError(ConditionToken:*Omit:*Omit);
         EndIf;
       EndIf;

       Return;

      /End-Free
     p                 e
