      *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)
      *_> DLTMOD MODULE(@5/@4)
      *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +
      *_>   DBGVIEW(@9) OPTIMIZE(@8) OPTION(*EVENTF)
      *=============================================================================================
      * Module.....: XVRSLV_M01
      * By.........: Alan Campin
      * Date.......: 10/07/2008
      * Purpose....: Implement resolve object. The AS/400 treats all storage as
      *                just memory so when the AS/400 wants to find an
      *                object in memory, it uses a single MI call to
      *                RSLVSP to convert a object name into a pointer to
      *                the object. These functions just encapsulate
      *                calls to RSLVSP.
      *---------------------------------------------------------------------------------------------
      * Program Modification Section:
      *------------------------------
      * By.........:
      * Date.......:
      * Description:                                                        l the
      *            :
      *
      *=============================================================================================
      /EJECT
     h nomain

      /copy *libl/qsrcf,cb_StdType

      /copy *libl/qsrcf,cb_Std_Con
      /copy *libl/qsrcf,xvrslv_PR
      /copy *libl/qsrcf,xverrh_pr

     d ConvertObjectTypeToHex...
     d                 pr             2
     d   PR_InObjectType...
     d                                     Like(StdNam)
     d                                     Value
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     * RSLV_ResolveToSystemPointer
     *   Function is responsilble for getting a system pointer to an
     *     AS/400 system object.
     *  In     Parms  - Object Name.
     *                  Object Library.
     *                  AS/400 Object Type.
     *  In/Out Parms  - None.
     *  Out    Parms  -
     *  Return        - System Pointer.
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     p RSLV_ResolveToSystemPointer...
     p                 b                   Export
     d                 pi                  Like(StdPrcPtr)
     d   InObjectName...
     d                                     Like(StdNam)
     d                                     Value
     d   InObjectLibrary...
     d                                     Like(StdNam)
     d                                     Value
     d   InObjectType...
     d                                     Like(StdNam)
     d                                     Value

     d ResolveToPointerAPI...
     d                 pr                  ExtProc('rslvsp')
     d                                     Like(StdPrcPtr)
     d   PR_HexType...
     d                                2    Value
     d   PR_Object...
     d                                     Like(StdPtr)
     d                                     Value
     d                                     Options(*String)
     d   PR_Library...
     d                                     Like(StdPtr)
     d                                     Value
     d                                     Options(*String)
     d   PR_Authority...
     d                                2    Value

     d HexType...
     d                 s              2
     d Authority...
     d                 s              2    Inz(*LoVal)
     d SystemPointer...
     d                 s                   Like(StdPrcPtr)
     d                                     Noopt
      /Free

       Monitor;
         HexType = ConvertObjectTypeToHex(InObjectType);
       On-Error;
         ERRH_Rethrow();
       EndMon;

       SystemPointer = ResolveToPointerAPI(HexType                :
                                           %TrimR(InObjectName)   :
                                           %TrimR(InObjectLibrary):
                                           Authority              );
       Return SystemPointer;

      /End-Free
     p                 e
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     * ConvertObjectTypeToHex
     *    Function is responsilble for taking an AS/400 object type and
     *      converting it to an internal hex representation.
     *  In     Parms - Object Type
     *  In/Out Parms - None.
     *  Out    Parms - None.
     *  Return       - Hex System Type.
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
     p ConvertObjectTypeToHex...
     p                 b
     d                 pi             2
     d   InObjectType...
     d                                     Like(StdNam)
     d                                     Value

      /copy *libl/qsrcf,CB_STD_EM

     d ApiQLICVTTP     pr                  ExtPgm('QLICVTTP')
     d   PR_ConversionType...
     d                                     Like(StdNam)
     d                                     Const
     d   PR_ObjectType...
     d                                     Like(StdNam)
     d                                     Const
     d   PR_HexType...
     d                                2
     d   PR_APIErrorReturn...
     d                                     LikeDs(TD_StdErrorModel)

     d HexType...
     d                 s              2    Inz(*Loval)
     d ApiError...
     d                 ds                  LikeDs(TD_StdErrorModel)
      /Free

       ApiError.Size = %Size(ApiError);
       ApiQLICVTTP('*SYMTOHEX' :
                   InObjectType:
                   HexType     :
                   ApiError    );

       If ApiError.BytesAvailable > 0;
         ERRH_Throw(ApiError.MessageId  :
                    cCPFMessageFileName :
                    ApiError.MessageData);
       Else;
         Return HexType;
       EndIf;

      /End-Free
     p                 e
